function [hrv,casy,polohy,hodnoty] = umocneni(ecg_filtred,M,fvz)
% detekovani QRS komplexu
%Fs=1000;
%okno=0.1*Fs;
%vzdalenost=Fs;
%prah= max (X(1:2*Fs));

N = length(ecg_filtred); 
index = 1;      % priprava indexu pro cyklus WHILE
polohy = [];    % sem budeme ukladat polohy zacatku
hodnoty = [];   % promn pro ukldn velikosti R-kmit
velikost_okna = (0.1*fvz); % delka okna velikosti predpokladane sirky QRS (100ms) 
pocitadlo = 0; % promena pro pocitani QRS komplexu
prum_vzdal = (1*fvz);   % odhad prmrn vzdlenosti
prah = max(ecg_filtred(1:2*fvz)); % poten nalezen maxima pro uren prahu
%M=0.4;

while index<N-velikost_okna
     if ecg_filtred(index)>prah*M     % rozhodovn zda je vzorek vt ne prh...
            cast = ecg_filtred(index:index+velikost_okna); % ...pokud ano aplikuje se okno 
            
            if pocitadlo==0     % pokud se jedn o prvn komplex
                [hodnota,poloha] = max(cast); % hledn maxima v okn
                polohy = [polohy, index+poloha]; % uloen polohy maxima
                hodnoty=[hodnoty, hodnota]; % uloen hodnoty maxima
                index = index + velikost_okna; % zven indexu pro dal hledn o dlku okna
                pocitadlo = pocitadlo + 1;  % zapoten QRS komplexu
                prah = hodnota; % nov hodnota pro nastaven prahu
            else 
                [hodnota_pom,poloha_pom] = max(cast);

                if ((poloha_pom+index)-(polohy(length(polohy))))>(0.15*prum_vzdal)  % min. vzdl sousednch komplex - vt ne 15% prm. vzdlenosti
                    polohy = [polohy, poloha_pom+index]; % uloen polohy maxima
                    hodnoty=[hodnoty, hodnota_pom]; % uloen hodnoty maxima
                    index = index + round(prum_vzdal/2); %velikost_okna;
                    pocitadlo = pocitadlo + 1;  % zapoten QRS komplexu
                    if hodnota_pom>0.5*prah     % podmnka proti sniovn prmrn velikosti R-kmitu v dsledku detekce malho pku neodpovdajcmu R-kmitu
                        prah = (prah+hodnota_pom)/2;    % prmrn velikost R-kmitu
                    end
                    if pocitadlo==2
                        prum_vzdal = polohy(2)-polohy(1);   % vpoet prm. vzdlenosti prvnch dvou R-kmit
                    end
                    
                    prum_vzdal = (prum_vzdal+(polohy(pocitadlo)-polohy(pocitadlo-1)))/2;    % zapoten QRS komplexu

                else
                    index = index + 1; % pokud nen splnna podmnka posun na dal vzorek
                end
            end
            
     else   % pokud nen splnna podmnka, e vzorek je vy ne prh
         if pocitadlo==0 % pokud nen detekovn dn komplex... 
             index = index + 1; %...zvyuje se index
         else
             if (index-(polohy(pocitadlo)))>(1.66*prum_vzdal)   % max. vzdl sousednch komplex - men ne 166% prm. vzdlenosti
                 index=polohy(pocitadlo)+round(prum_vzdal/2);   % odkud se bude detekovat se snenm prahem
                 if M>=0.2  % snen koeficientu urujc prh
                    M = M - 0.1;
                 else 
                    M=0.4;    % nastaven zkladnch 40% z prm velikosti
                    prum_vzdal=prum_vzdal+prum_vzdal/10; % zven prm. vzdlenosti
                 end 
             else
                index = index + 1;
             end             
         end
     end
end
                        
%disp(['V EKG signalu bylo detekovano ... ' num2str(pocitadlo) ' ... QRS komplexu.'])

prahgraf(1:index) = prah*M; 
  tt = 1/fvz:1/fvz:ceil(index/fvz); 
  t = tt(1:index);
  for i= 1:pocitadlo
      casy(i) = t(polohy(i));
  end
 hrv = diff(casy);

 figure(1111)
 hold off;
 subplot(2,1,1)
 
 plot(ecg_filtred)
 
 hold on;
 plot(prahgraf);
 plot(polohy,hodnoty,'+k')
 title('Signl EKG s detekovanmi R vlnami')
 ylabel('EKG [mV]')
 xlabel('vzorek [-]')
 hold off;
 
 subplot(2,1,2)
 hold on;
 plot(casy(1:length(hrv)),hrv)
 title('RR intervaly')
 ylabel('RR [s]')
 xlabel('t [s]')
 hold off;
